<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE mapper PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN" "http://mybatis.org/dtd/mybatis-3-mapper.dtd">

<mapper namespace="com.zipdoc.acs.persistence.dao.ZipdocReplyDao">
	<resultMap id="zipdocReplyResult" type="ZipdocReply">
		<id property="cno" column="CNO" />
		<result property="subject" column="SUBJECT"/>
		<result property="contents" column="CONTENTS"/>
		<result property="view_cnt" column="VIEW_CNT"/>
		<result property="reply_cnt" column="REPLY_CNT"/>
		<result property="creater" column="CREATER"/>
		<result property="create_date" column="CREATE_DATE"/>
		<association property="profile" javaType="Profile" >
			<id property="member_no" column="MEMBER_NO"/>
			<result property="nickname" column="NICKNAME"/>
			<result property="profile_url" column="PROFILE_URL"/>
		</association>
	</resultMap>

	<select id="selectListTotalCount" parameterType="com.zipdoc.acs.model.ZipdocReplyListRequest" resultType="int">
		SELECT COUNT(*)
		FROM T_REPLY P
		WHERE 'x' = 'x'
		<if test="keyword != null and keyword != ''">
			AND (
					(P.SUBJECT LIKE CONCAT('%', #{keyword}, '%'))
					OR
					(P.CONTENTS LIKE CONCAT('%', #{keyword}, '%'))
			)
		</if>
		<if test="owner == 1 and member_no != null and member_no > 0">
			AND CREATER = #{member_no}
		</if>
	</select>

	<select id="selectList" parameterType="com.zipdoc.acs.model.ZipdocReplyListRequest" resultMap="zipdocReplyResult">
        SELECT
			 P.CNO AS CNO
          	,P.SUBJECT AS SUBJECT
			,P.CONTENTS AS CONTENTS
			,P.VIEW_CNT AS VIEW_CNT
			,P.CREATER AS CREATER
			,P.CREATE_DATE AS CREATE_DATE
			,(SELECT COUNT(*) FROM T_REPLY_REPLY R WHERE R.CNO = P.CNO) AS REPLY_CNT
			,P.CREATER AS MEMBER_NO
			,M.NICKNAME AS NICKNAME
			,M.PROFILE_URL AS PROFILE_URL
        FROM T_REPLY P, T_MEMBER M
		WHERE P.CREATER = M.MEMBER_NO
		<if test="keyword != null and keyword != ''">
			AND (
					(P.SUBJECT LIKE CONCAT('%', #{keyword}, '%'))
					OR
					(P.CONTENTS LIKE CONCAT('%', #{keyword}, '%'))
			)
		</if>
		<if test="owner == 1 and member_no != null and member_no > 0">
			AND P.CREATER = #{member_no}
		</if>
		<if test="sort == 0">
			ORDER BY P.VIEW_CNT DESC
		</if>
		<if test="sort == 1">
			ORDER BY P.VIEW_CNT DESC
		</if>
		<if test="sort == 2">
			ORDER BY P.CREATE_DATE DESC
		</if>
        LIMIT #{startRow}, #{limit}
    </select>

	<select id="selectById" parameterType="long" resultMap="zipdocReplyResult">
		SELECT
			 P.CNO AS CNO
          	,P.SUBJECT AS SUBJECT
			,P.CONTENTS AS CONTENTS
			,P.VIEW_CNT AS VIEW_CNT
			,P.CREATER AS CREATER
			,P.CREATE_DATE AS CREATE_DATE
			,(SELECT COUNT(*) FROM T_REPLY_REPLY R WHERE R.CNO = P.CNO) AS REPLY_CNT
			,P.CREATER AS MEMBER_NO
			,M.NICKNAME AS NICKNAME
			,M.PROFILE_URL AS PROFILE_URL
		FROM T_REPLY P, T_MEMBER M
		WHERE P.CNO = #{cno}
		  AND P.CREATER = M.MEMBER_NO
	</select>

	<insert id="create" parameterType="ZipdocReply">
		INSERT INTO T_REPLY (
          	 SUBJECT
			,CONTENTS
			,VIEW_CNT
			,IP
			,CREATER
			,CREATE_DATE
		)
		VALUES (
			 #{subject}
			,#{contents}
			,0
			,#{ip}
			,#{creater}
			,NOW()
		)
	</insert>

	<delete id="delete" parameterType="long">
		DELETE FROM T_REPLY
		WHERE CNO = #{cno}
	</delete>

	<delete id="deleteReply" parameterType="long">
		DELETE FROM T_REPLY_REPLY
		WHERE CNO = #{cno}
	</delete>

	<update id="updateIncreaseViewCnt" parameterType="long">
		UPDATE T_REPLY
		   SET VIEW_CNT = VIEW_CNT + 1
		 WHERE CNO = #{cno}
	</update>
</mapper>